<?php
/**
 * @version      $Id: list.php 14401 2010-01-26 14:10:00Z louis $
 * @package      Joomla.Framework
 * @subpackage   Parameter
 * @copyright    Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license      GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

// Joomla 1.5
jimport('joomla.html.parameter.element');
// Joomla 1.6
jimport('joomla.html.html');
jimport('joomla.form.formfield'); //import the necessary class definition for formfield

/**
 * Renders a list element
 *
 * @package     Joomla.Framework
 * @subpackage      Parameter
 * @since       1.5
 */
// Joomla 1.5
//class JElementUnisenderList extends JElement
// Joomla 1.6
class JFormFieldUnisenderListSubs extends JFormField
{
	/**
	 * Element type
	 *
	 * @access   protected
	 * @var      string
	 */
	var $_name = 'UnisenderListSubs';
	protected $type = 'UnisenderListSubs';

	// Joomla 1.5
	//function fetchElement($name, $value, &$node, $control_name)
	// Joomla 1.6
	public function getInput()
	{
		// Joomla 1.6
		$name = $this->name;
		$value = $this->value;
		$node = $this->node;
		$control_name = $this->control_name;
		// end of Joomla 1.6

		$html = '';
		$module_path = dirname(dirname(__FILE__));
		$helper_file = $module_path . '/helper.php';
		require_once($helper_file);
		$helper = new ModUnisenderHelper();
		$params = $helper->getParams('mod_unisender');
		// restore list id
		$list_id = isset($params['UNISENDER_LIST'])
			? $params['UNISENDER_LIST']
			: '';
		$list_id = empty($list_id) && isset($params['UNISENDER_IMPORT_LIST'])
			? $params['UNISENDER_IMPORT_LIST']
			: $list_id;
		$group_id = (int)$value;
		$PORTION = 5;

		// html element
		//$class = ( $node->attributes('class') ? 'class="'.$node->attributes('class').'"' : 'class="inputbox"' );
		$class = "inputbox";
		$groups = $helper->getGroupsSubs();
		$options = array();
		if (count($groups) > 0)
			foreach ($groups as $group) {
				$val = $group['id'];
				$text = $group['title'];
				$options[] = JHTML::_('select.option', $val, $text);
			}

		$html .= JHTML::_('select.genericlist', $options, '' . $name, $class, 'value', 'text', $list_id, $name);

		// paramsUNISENDER_LIST
		return $html;
	}

	public function getLabel()
	{
		return '<label id="jform_params_UNISENDER_LIST-lbl" for="jform_params_UNISENDER_LIST" aria-invalid="false">Subscriber list</label>';
	}
}
